//pv algorithm
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.PriorityQueue;
import java.util.Stack;

import Geometry.*;
import Polynomial.*;

public class SurfacePV extends Surface{
   //double sizeFactor=8;
   //LinkedList<Cube> C0=new LinkedList<Cube>(); //C0 cubes
//   Cube testCube=new Cube(new Point(1,0,0.5), new Point(1.5, 0.5, 1));
   public SurfacePV(Poly3 p, Cube c, double sizeFactor){
	   Poly3 px=p.derivative('x');
	   Poly3 py=p.derivative('y');
	   Poly3 pz=p.derivative('z');
	   HashMap<Point, Integer> v=new HashMap<Point, Integer>();
	   PriorityQueue<Cube> Q1 = new PriorityQueue<Cube>(100000,new sizeComparator()); //Cxyz cubes
	   PriorityQueue<Cube> Q2; //Balanced Cxyz Cubes
	   Stack<Cube> Q0=new Stack<Cube>();
	   ArrayList<Point[]> f=new ArrayList<Point[]>();
		  
	   Q0.add(c);
	   /****************************
	    *subdivision criteria
	    ****************************/
	   while (!Q0.isEmpty()){
		   Cube t1=Q0.pop();
		   if (t1.C0(p)){
			   //removeC0(t1);
		   }
		   else if(t1.C1(p, px, py, pz)){
			   Q1.add(t1);
		   }
		   else{
			   LinkedList<Cube> tempQ=t1.split();
			   counter+=7;
			   //System.out.println(counter);
			   for (int i=0; i<tempQ.size(); i++)
				   Q0.add(tempQ.get(i));
		   }
	   }
	   System.out.println("subdivision criteria");
	   System.out.println("number of boxes="+counter);
	   System.out.println();
		  
	   /****************************
	    *balance
	    ****************************/
	   Q2=balance(Q1,p);
	   System.out.println("balance");
	   System.out.println("number of boxes="+counter);
	   System.out.println();

	   /****************************
	    *construction
	    ****************************/
//	   System.out.println(Q2.size());
//	   int abc=0;
//	   checkDuplication(Q2);
//		checkInclusion(Q2);
	   while (!Q2.isEmpty()){
		   Cube tc=Q2.poll();
//		   abc++;
		   tc.addV(p);
//		   if (abc==228){
//			   tc.print();
//			   System.out.println("found it");
//			   tc.printVertices();
//			   for (int i=0; i<8; ++i)
//				   System.out.print(tc.pc[i]);
//			   for (int i=0; i<8; ++i)
//				   if (Math.abs(p.value(tc.corners[i]))<0.01)
//					   System.out.println(i+"corner");
//		   }
		   Iterator<Point> iter=tc.getVertices().iterator();
		   while (iter.hasNext())
			   v.put(iter.next(), 0);
		   tc.link(p, px, py, pz);
		   tc.findLoop();
		   tc.triangulate(v);
//		   if (abc==228){
//			   for (int i=0; i<tc.getLoops().get(0).size(); ++i)
//				   tc.getLoops().get(0).get(i).print();
		   for (int i=0; i<tc.getFaces().size(); ++i)
			   f.add(tc.getFaces().get(i));
//		   }
		   boxes.add(tc);
	   }
	   
	   setFaces(v, f, px, py, pz, sizeFactor);
   }
}
